#include <math.h>
#include "wspr.h"
#include <SDL/SDL.h>
#include "asteroids.h"

void drawSDL(Surface &screen,SDL_Surface *screensdl) {
  S32 len=640*480;
  for (S32 i=0;i<len;i++) {
    U32 px;
    if (screen.pixels[i]==0x0080ff80) px=0;
    else px=wspr_YCAC_to_RGBA(screen.pixels[i])>>8;
    ((U32*)screensdl->pixels)[i]=px;
  }
  SDL_Flip(screensdl);
}

int main(int argc,char **argv) {
  srand(time(0));
  if (SDL_Init(SDL_INIT_EVERYTHING)) exit(1);
  SDL_Surface *screensdl;
  if (!(screensdl=SDL_SetVideoMode(640,480,32,SDL_HWSURFACE))) exit(1);
  
  Surface screen(640,480,PIXFMT_RGBA);
  Graphics g(screen);
  g.foreColor(0xbb20ff80);
  g.backColor(0x0080ff80);
  Game game;
  
  Ship p1(&game,320,240);
  p1.playernum=1;
  
  bool quit=false;
  bool btnleft=false,btnright=false;
  S32 lasttick=SDL_GetTicks();
  while (!quit) {
    if (SDL_GetTicks()-lasttick>=16) {
      lasttick=SDL_GetTicks();
      game.update();
      game.draw(g);
      drawSDL(screen,screensdl);
    
      SDL_Event evt;
      while (SDL_PollEvent(&evt)) switch (evt.type) {
        case SDL_QUIT: quit=1; break;
        case SDL_KEYDOWN: switch (evt.key.keysym.sym) {
          case SDLK_SPACE: p1.fire(); break;
          case SDLK_LEFT:  btnleft=true; break;
          case SDLK_RIGHT: btnright=true; break;
          case SDLK_ESCAPE: quit=true; break;
        } break;
        case SDL_KEYUP: switch (evt.key.keysym.sym) {
          case SDLK_LEFT: btnleft=false; break;
          case SDLK_RIGHT: btnright=false; break;
        } break;
      }
      
      if (btnleft) p1.facet-=0.1;
      else if (btnright) p1.facet+=0.1;
    }
  }
  return 0;
}
